package com.jiuqi.grid;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class Matrix implements Serializable {
  private int xCount;
  
  private int yCount;
  
  private List list = new ArrayList();
  
  public int getXCount() {
    return this.xCount;
  }
  
  public int getYCount() {
    return this.yCount;
  }
  
  public void setSize(int xSize, int ySize) {
    if (xSize < 0 || ySize < 0)
      return; 
    int c = 0;
    if (this.xCount != xSize) {
      int i;
      for (i = this.xCount; i < xSize; i++)
        this.list.add(new ArrayList()); 
      c = this.list.size();
      for (i = c; i > xSize; i--)
        this.list.remove(i - 1); 
      this.xCount = xSize;
    } 
    if (this.yCount < ySize) {
      for (int i = 0; i < this.xCount; i++) {
        List data = this.list.get(i);
        if (data != null)
          for (int j = this.yCount; j < ySize; j++)
            data.add(null);  
      } 
      this.yCount = ySize;
    } 
    if (this.yCount > ySize) {
      for (int i = 0; i < this.xCount; i++) {
        List data = this.list.get(i);
        if (data != null) {
          c = data.size();
          for (int j = c; j > ySize; j--)
            data.remove(j - 1); 
        } 
      } 
      this.yCount = ySize;
    } 
  }
  
  public void resetSize(int xSize, int ySize) {
    setSize(xSize, ySize);
    for (int x = 0; x < getXCount(); x++) {
      for (int y = 0; y < getYCount(); y++)
        setElement(x, y, null); 
    } 
  }
  
  public Object getElement(int x, int y) {
    if (x >= 0 && y >= 0 && x < this.xCount && y < this.yCount) {
      List data = this.list.get(x);
      if (data != null && y < data.size())
        return data.get(y); 
      return null;
    } 
    return null;
  }
  
  public void setElement(int x, int y, Object obj) {
    if (x >= 0 && y >= 0 && x < this.xCount && y < this.yCount) {
      List<Object> data = this.list.get(x);
      if (data == null && obj != null) {
        data = new ArrayList();
        this.list.set(x, data);
      } 
      if (data != null) {
        for (int i = data.size(); i < this.yCount; i++)
          data.add(null); 
        data.set(y, obj);
      } 
    } 
  }
  
  public boolean hasElement(Object o) {
    for (int i = 0; i < this.list.size(); i++) {
      List data = this.list.get(i);
      if (data != null && data.indexOf(o) >= 0)
        return true; 
    } 
    return false;
  }
  
  public void xDelete(int x) {
    this.list.remove(x);
    this.xCount--;
  }
  
  public void xDelete(int x, int count) {
    for (int i = 0; i < count; i++)
      xDelete(x); 
  }
  
  public void yDelete(int y) {
    for (int i = 0; i < this.list.size(); i++) {
      List data = this.list.get(i);
      if (data != null && y < data.size())
        data.remove(y); 
    } 
    this.yCount--;
  }
  
  public void yDelete(int y, int count) {
    for (int i = 0; i < count; i++)
      yDelete(y); 
  }
  
  public void xInsert(int x, int count) {
    for (int i = 0; i < count; i++)
      this.list.add(x, null); 
    this.xCount += count;
  }
  
  public void yInsert(int y, int count) {
    if (y < 0 || y > this.yCount)
      return; 
    for (int i = 0; i < this.list.size(); i++) {
      List data = this.list.get(i);
      if (data != null && y <= data.size())
        for (int k = 0; k < count; k++)
          data.add(y, null);  
    } 
    this.yCount += count;
  }
  
  public void xExchange(int x1, int x2) {
    if (x1 < 0 || x2 < 0 || x1 >= this.xCount || x2 >= this.xCount)
      return; 
    Object data = this.list.get(x1);
    this.list.set(x1, this.list.get(x2));
    this.list.set(x2, data);
  }
  
  public void yExchange(int y1, int y2) {
    if (y1 < 0 || y2 < 0 || y1 >= this.yCount || y2 >= this.yCount || y1 == y2)
      return; 
    for (int i = 0; i < this.list.size(); i++) {
      List<Object> data = this.list.get(i);
      if (data != null && (y1 < data.size() || y2 < data.size())) {
        for (int k = data.size(); k < this.yCount; k++)
          data.add(null); 
        Object o = data.get(y1);
        data.set(y1, data.get(y2));
        data.set(y2, o);
      } 
    } 
  }
  
  public void xCopy(int fromIndex, int toIndex) {
    List data = this.list.get(fromIndex);
    if (data == null) {
      this.list.set(toIndex, null);
    } else {
      List newData = new ArrayList();
      newData.addAll(data);
      this.list.set(toIndex, newData);
    } 
  }
  
  public void yCopy(int fromIndex, int toIndex) {
    for (int i = 0; i < this.list.size(); i++) {
      List data = this.list.get(i);
      if (data != null && (fromIndex < data.size() || toIndex < data.size())) {
        for (int k = data.size(); k < this.yCount; k++)
          data.add(null); 
        data.set(toIndex, data.get(fromIndex));
      } 
    } 
  }
}
